import net.sf.jasperreports.engine.*;
import java.text.SimpleDateFormat;
import java.util.*;
import java.io.*;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

public class TemplateReportScriptlet extends
net.sf.jasperreports.engine.JRAbstractScriptlet {
	/** Creates a new instance of JRAbstractScriptlet */
	public String DatePrepare(String rpt_type, String rt_ty, String sdt,
			String display) {

		Calendar cal = Calendar.getInstance();
		Date dt = new Date();
		String frmdt, todt, frmdtdisp, todtdisp, format1, format2, format3, dtfrmt;
		frmdt = todt = frmdtdisp = todtdisp = dtfrmt = "";
		int yr = cal.get(Calendar.YEAR);
		int mnth = cal.get(Calendar.MONTH) + 1;
		format1 = "yyyy-MM-dd HH:mm:ss";
		format2 = "MMMM dd, yyyy hh:mm:ss a";
		format3 = "MMMM dd, yyyy hh:mm:ss a zzz";

		if (rpt_type.equals("D")) {
			dtfrmt = cal.get(Calendar.DATE) + "/" + mnth + "/" + yr;
			frmdt = DateConvert(dtfrmt + " 00:00:00", format1, "GMT");
			todt = DateConvert(dtfrmt + " 23:59:59", format1, "GMT");
			frmdtdisp = DateConvert(dtfrmt + " 00:00:00", format2, "");
			todtdisp = DateConvert(dtfrmt + " 23:59:59", format3, "");
		} else if (rpt_type.equals("W")) {
			Date dt1 = null;
			Calendar rightNow = Calendar.getInstance();
			int day = rightNow.get(Calendar.DAY_OF_WEEK);
			int distance = 0;
			if (day == Calendar.SUNDAY) {
				dt1 = rightNow.getTime();
			} else {
				distance = day - Calendar.SUNDAY;
				dt1 = (Date) (rightNow.getTime());
				dt1.setTime(dt1.getTime() - 1000 * 60 * 60 * 24 * (distance));
			}
			String dtfrmt1 = ((new SimpleDateFormat("dd/MM/yyyy")).format(dt1));
			frmdt = DateConvert(dtfrmt1 + " 00:00:00", format1, "GMT");
			todt = DateConvert(cal.get(Calendar.DATE) + "/" + mnth + "/" + yr
					+ " 23:59:59", format1, "GMT");
			frmdtdisp = DateConvert(dtfrmt1 + " 00:00:00", format2, "");
			todtdisp = DateConvert(cal.get(Calendar.DATE) + "/" + mnth + "/"
					+ yr + " 23:59:59", format3, "");
		} else if (rpt_type.equals("PW")) {
			Date dt1 = null;
        	        cal.add( Calendar.DAY_OF_MONTH, -7 );
	                cal.set( Calendar.DAY_OF_WEEK, Calendar.SUNDAY );
			dt1 = cal.getTime();
			String dtfrmt1 = ((new SimpleDateFormat("dd/MM/yyyy")).format(dt1));
			frmdt = DateConvert(dtfrmt1 + " 00:00:00", format1, "GMT");
			frmdtdisp = DateConvert(dtfrmt1 + " 00:00:00", format2, "");
	                cal.set( Calendar.DAY_OF_WEEK, Calendar.SATURDAY );
			dt1 = cal.getTime();
			String dtfrmt2 = ((new SimpleDateFormat("dd/MM/yyyy")).format(dt1));
			todt = DateConvert(dtfrmt2 + " 23:59:59", format1, "GMT");
			todtdisp = DateConvert(dtfrmt2 + " 23:59:59", format3, "");
		} else if (rpt_type.equals("PD")) {
			int MILLIS_IN_DAY = 1000 * 60 * 60 * 24;
			SimpleDateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy");
			String prevDate = dateFormat.format(dt.getTime() - MILLIS_IN_DAY);
			frmdt = DateConvert(prevDate + " 00:00:00", format1, "GMT");
			todt = DateConvert(prevDate + " 23:59:59", format1, "GMT");
			frmdtdisp = DateConvert(prevDate + " 00:00:00", format2, "");
			todtdisp = DateConvert(prevDate + " 23:59:59", format3, "");
		} else if (rpt_type.equals("M")) {
			frmdt = DateConvert("01/" + mnth + "/" + yr + " 00:00:00", format1,
			"GMT");
			todt = DateConvert(cal.get(Calendar.DATE) + "/" + mnth + "/" + yr
					+ " 23:59:59", format1, "GMT");
			frmdtdisp = DateConvert("01/" + mnth + "/" + yr + " 00:00:00",
					format2, "");
			todtdisp = DateConvert(cal.get(Calendar.DATE) + "/" + mnth + "/"
					+ yr + " 23:59:59", format3, "");
		} else if (rpt_type.equals("PM")) {
			int prevmnth = cal.get(Calendar.MONTH);
        	        cal.add( Calendar.MONTH, -1 );
	                int prevmnthlastday = cal.getActualMaximum(Calendar.DAY_OF_MONTH);
			frmdt = DateConvert("01/" + prevmnth + "/" + yr + " 00:00:00", format1,
			"GMT");
			todt = DateConvert(prevmnthlastday + "/" + prevmnth + "/" + yr
					+ " 23:59:59", format1, "GMT");
			frmdtdisp = DateConvert("01/" + prevmnth + "/" + yr + " 00:00:00",
					format2, "");
			todtdisp = DateConvert(prevmnthlastday + "/" + prevmnth + "/"
					+ yr + " 23:59:59", format3, "");
		} else if (rpt_type.equals("DR")) {
			if (rt_ty.equals("F")) {
				frmdt = DateConvert(sdt, format1, "GMT");
				frmdtdisp = DateConvert(sdt, format2, "");
			} else {
				todt = DateConvert(sdt, format1, "GMT");
				todtdisp = DateConvert(sdt, format3, "");
			}
		}
		if (display.equals("")) {
			return (rt_ty.equals("F") ? frmdt : todt);
		} else {
			return (display.equals("DF") ? frmdtdisp : todtdisp);
		}
	}

	public String DateConvert(String DateOfPar, String DateForm, String TimZo) {
		SimpleDateFormat dateFormat1, dateFormat2;
		String dateAsString = "";
		try {
			dateFormat1 = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
			Date dt = dateFormat1.parse(DateOfPar);
			dateFormat2 = new SimpleDateFormat(DateForm);
		/**  Used to convert to GMT
			if (!TimZo.equals("")) {
				dateFormat2.setTimeZone(TimeZone.getTimeZone(TimZo));
			}
		*/
			dateAsString = dateFormat2.format(dt);
		} catch (Exception poe) {
		}
		return (dateAsString);
	}






















/** Begin EVENT_AFTER_COLUMN_INIT This line is generated by iReport. Don't modify or move please! */
	public void afterColumnInit() throws JRScriptletException
	{

	}
/** End EVENT_AFTER_COLUMN_INIT This line is generated by iReport. Don't modify or move please! */
/** Begin EVENT_AFTER_DETAIL_EVAL This line is generated by iReport. Don't modify or move please! */
	public void afterDetailEval() throws JRScriptletException
	{

	}
/** End EVENT_AFTER_DETAIL_EVAL This line is generated by iReport. Don't modify or move please! */
/** Begin EVENT_AFTER_GROUP_INIT This line is generated by iReport. Don't modify or move please! */
	public void afterGroupInit(String groupName) throws JRScriptletException
	{

	}
/** End EVENT_AFTER_GROUP_INIT This line is generated by iReport. Don't modify or move please! */
/** Begin EVENT_AFTER_PAGE_INIT This line is generated by iReport. Don't modify or move please! */
	public void afterPageInit() throws JRScriptletException
	{

	}
/** End EVENT_AFTER_PAGE_INIT This line is generated by iReport. Don't modify or move please! */
/** Begin EVENT_AFTER_REPORT_INIT This line is generated by iReport. Don't modify or move please! */
	public void afterReportInit() throws JRScriptletException
	{

	}
/** End EVENT_AFTER_REPORT_INIT This line is generated by iReport. Don't modify or move please! */
/** Begin EVENT_BEFORE_COLUMN_INIT This line is generated by iReport. Don't modify or move please! */
	public void beforeColumnInit() throws JRScriptletException
	{

	}
/** End EVENT_BEFORE_COLUMN_INIT This line is generated by iReport. Don't modify or move please! */
/** Begin EVENT_BEFORE_DETAIL_EVAL This line is generated by iReport. Don't modify or move please! */
	public void beforeDetailEval() throws JRScriptletException
	{

	}
	/** end EVENT_BEFORE_DETAIL_EVAL Please don't touch or move this comment*/

/** End EVENT_BEFORE_DETAIL_EVAL This line is generated by iReport. Don't modify or move please! */
/** Begin EVENT_BEFORE_GROUP_INIT This line is generated by iReport. Don't modify or move please! */
	public void beforeGroupInit(String groupName) throws JRScriptletException
	{

	}
/** End EVENT_BEFORE_GROUP_INIT This line is generated by iReport. Don't modify or move please! */
/** Begin EVENT_BEFORE_PAGE_INIT This line is generated by iReport. Don't modify or move please! */
	public void beforePageInit() throws JRScriptletException
	{

	}
/** End EVENT_BEFORE_PAGE_INIT This line is generated by iReport. Don't modify or move please! */
/** Begin EVENT_BEFORE_REPORT_INIT This line is generated by iReport. Don't modify or move please! */
	public void beforeReportInit() throws JRScriptletException
	{

	}
/** End EVENT_BEFORE_REPORT_INIT This line is generated by iReport. Don't modify or move please! */

}